#pragma once

// STD/STL
#include <memory>

// BaseClass
#include "../Converter.h"

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx::armem::server::ltm::processor::converter::data
{
    class ObjectConverter : public DataConverter
    {
    public:
        ObjectConverter(const ConverterType t, const std::string& id, const std::string& s) :
            DataConverter(t, id, s, aron::type::Descriptor::OBJECT, nullptr)
        {
        }

        virtual ~ObjectConverter() = default;

        ConversionResult convert(const aron::data::VariantPtr& data) final;
        aron::data::VariantPtr convert(const ConversionResult& data,
                                       const armarx::aron::Path& p) final;

    protected:
        virtual ConversionResult _convert(const aron::data::DictPtr& data) = 0;
        virtual aron::data::DictPtr _convert(const ConversionResult& data,
                                             const armarx::aron::Path& p) = 0;
    };
} // namespace armarx::armem::server::ltm::processor::converter::data
